package ex.videoP2P.logic {
	import ex.videoP2P.SelfVideoWig;

	import org.gamina.api.ITraitsBus;
	import org.gamina.api.IWidget;
	import org.gamina.api.logic.ITrait;
	import org.gamina.srv.AbstractP2PGroup;

	import flash.media.Camera;

	public class SelfVidPublish extends AbstractP2PGroup implements ITrait {
		protected var _wig : SelfVideoWig;
		// directly manipulate
		private var  _webCam : Camera;
		private var  _streamName : String;
		// https://github.com/OpenRTMFP/Cumulus
		private static const DEVKEY : String = '714e12fee6c4dc50154f8204-a114141a8df6';
		public var streamGUID : String = 'someGUID';

		public function SelfVidPublish(bus_ : ITraitsBus) {
			_bus = bus_
			_bus.registerTrait(this);
		}

		public function initTrait(wig_ : IWidget) : ITrait {
			_wig = SelfVideoWig(wig_);
			startPub(streamGUID);
			return this;
		}

		// you can vary the quality HML -  (L)4g, (M)wifiN, (H)wired
		public function setCamQuality(q : uint = 2) : void {
			// HML
			// assume high
			_webCam.setMode(1280 * .75, 720 * .75, 28, true);
			_webCam.setQuality(0, 90);

			// this should go to nav trait
			_wig.width = 1280 / 6;
			_wig.height = 720 / 6;
			_wig.x = _bus.stageReference.stageWidth - 1280 / 6;
			_wig.y = _bus.stageReference.stageHeight - 720 / 6;
			_wig.alpha = .8;
		}

		public function startPub(streamName : String, camNum : uint = 0) : void {
			_streamName = streamName;
			_webCam = Camera.getCamera();
			trace(_webCam.name);
			setCamQuality();

			_nc.connect(P2P_INTRO_SRV + DEVKEY);
			// dis onConnect
		}

		override  protected function onConnect() : void {
			_netSCh.attachCamera(_webCam);
			_netSCh.publish(_streamName);
			_wig.attachCamera(_webCam);
		}

		public function get traitId() : String {
			return 'pub';
		}
	}
}