package fsm.logic {
	import flash.events.MouseEvent;
	import fsm.SMWig;
	import org.gamina.api.ITraitsBus;
	import org.gamina.api.IWidget;
	import org.gamina.api.logic.ITrait;
	import org.gamina.api.logic.sm.ISatefulTrait;
	import org.osflash.signals.ISignal;
	import org.osflash.signals.natives.NativeSignal;

	public class SMTrait implements ISatefulTrait {
		private var _bus : ITraitsBus;
		private var _wig : SMWig;

		public function transitionToState(stateKey : String, newStateValue : Object=null) : void {
			var oldS : uint = uint(_bus.SM.getCurrentState(traitId, stateKey));
			//if(oldS==null) oldS=0;
			trace('old state', oldS);
			_bus.SM.setState(traitId,stateKey,oldS+1);
			trace('new state', _bus.SM.getCurrentState(traitId, stateKey));
		}

		public function SMTrait(bus_ : ITraitsBus) {
			_bus = bus_;
		}

		public function initTrait(wig_ : IWidget) : ITrait {
			_wig = SMWig(wig_);
												
			//_wig.butA.addEventListener(MouseEvent.CLICK, onClicked);
			var clickedSignal:NativeSignal = new NativeSignal(_wig.butA,MouseEvent.CLICK);
			clickedSignal.add(onClicked);
			return this;
		}

		protected function onClicked(evt:MouseEvent):void {
			trace('clicked');
			transitionToState('C');
		}

		public function get traitId() : String {
			return 'FSMEx1';
		}

		public function get mainBus() : ITraitsBus {
			return _bus;
		}

		public function get exec() : ISignal {
			return null;
		}

		public function get traitConcern() : String {
			return 'SM';
		}
	}
}
