var signal=require('signals');

// JSON protocol
var CLIENT_ID='CLIENT_ID_';

var HANDLER='HANDLER_';
var LOG='LOG_';
var PING='PING_';
var FIRST_RESP='FIRST_RESP_';

var USER_NAME='USER_NAME_';


var BasicConnections = module.exports = function() {}


BasicConnections.prototype.init=function(server) {
    this._connections = new Object();
    this._server = server;
    this._msgSignal = new signal.Signal();

}

BasicConnections.prototype.add=function(cid,connection){
    this._connections[cid]=connection;

    //send cid and FIRST MSG
    var firstMsg = new Object();
    firstMsg[HANDLER]=FIRST_RESP;
    
    sendTo(cid,firstMsg);
}

BasicConnections.prototype._getConn=function(cid) {
    return this._connections[cid];
}

BasicConnections.prototype.setUserName=function(cid,userName,userDomain) {
    var conn=this._getConn(cid);
    conn[USER_NAME]=userName;
}

// sends a JSON array, msg should be an object
BasicConnections.prototype.sendTo=function(cid,msgObj) {
    var conn=this._getConn(cid);
    msgObj[CLIENT_ID]=cid;
    var msg=JSON.stringify(msgObj);
    msg='['+msg+']';
    //conn.send(msg);
    this._server.broadcast[msg];
}

//received msg is a JSON string, it needs to be converted to obj and dispatch
BasicConnections.prototype.handleMsg=function(sid,msg) {
    console.log(msg);
    var msgObj = JSON.parse(msg);
    var cid=msgObj.CLIENT_ID_;
    //sid and cid should match
    var handler=msgObj.HANDLER_;
    if(FIRST_RESP==handler) {
        var conn=this._getConn(cid);
        con[USER_NAME]=msgObj[USER_NAME];
        return;
    }
    this._msgSignal.dispatch(handler,msg);
    
}

BasicConnections.prototype.getMsgSignal=function() {
    return this._msgSignal;
}

//send,ping,doLog