package gamina;

import java.io.InputStream;
import java.util.List;

import net.htmlparser.jericho.Element;
import net.htmlparser.jericho.HTMLElementName;
import net.htmlparser.jericho.ParseText;
import net.htmlparser.jericho.Segment;
import net.htmlparser.jericho.Source;

import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.HttpMethod;
import org.apache.commons.httpclient.HttpStatus;
import org.apache.commons.httpclient.URI;
import org.apache.commons.httpclient.methods.GetMethod;
import org.apache.commons.httpclient.methods.HeadMethod;
import org.json.simple.JSONArray;
import org.json.simple.JSONObject;

public class ExtractUtil {

	public static String TITLE = "TITLE_";
	public static String SURL = "SURL_";
	public static String PAGE = "PAGE_";
	public static String SIZE = "SIZE_";
	public static String TYPE = "TYPE_";
	
	public static void main(String[] args) {
		try {
			System.out.println(getAny("http://hexawe.net", ".mp3"));
			System.out.println(getImages("http://espn.com"));
			System.out.println(getLinks("http://hexawe.net"));
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public static JSONArray getAny(String surl, String ext)  {
		JSONArray list = new JSONArray();
		Source source;
		try {
			source = getPageSource(surl);
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		String domain = "http://" + parseDomainUrl(surl);

		if (ext == null)
			ext = ".flv";
		int cur = 0;
		ParseText pageSource = source.getParseText();
		String viewSource = pageSource.toString();
		cur = viewSource.indexOf(ext, cur);
		JSONObject row;
		while (cur > -1) {
			try {
				
				int startDQ =0;
				int startSQ =0;
				int startA =0;
				int startS =0;
				int startH =0;
				
				startDQ = viewSource.lastIndexOf("\"", cur);// find "
				startSQ = viewSource.lastIndexOf("\'", cur);// find '
				startA = viewSource.lastIndexOf(">", cur);
				startS = viewSource.lastIndexOf(" ", cur);
				startH = viewSource.lastIndexOf("http:", cur);// find http
				startH--;
				// make it closest
				int start = (startDQ > startSQ ? startDQ : startSQ);
				start = (startA > start ? startA : start);
				start = (start > startS ? start : startS);
				start = (start > startH ? start : startH);
				
				//make it closest
				int endDQ = Integer.MAX_VALUE;
				int endSQ = Integer.MAX_VALUE;
				int endA = Integer.MAX_VALUE;
				int endS = Integer.MAX_VALUE;
				
				endDQ = viewSource.indexOf("\"", cur);// find "
				endSQ = viewSource.indexOf("\'", cur);// find '
				endA = viewSource.indexOf("<", cur);
				endS = viewSource.indexOf(" ", cur);
				if(endDQ<0) endDQ= Integer.MAX_VALUE;
				if(endSQ<0) endSQ= Integer.MAX_VALUE;
				if(endA<0) endA= Integer.MAX_VALUE;
				if(endS<0) endS= Integer.MAX_VALUE;
				
				int end = (endDQ < endSQ ? endDQ : endSQ);
				end=(endA < end ? endA : end);
				end=(endS < end ? endS : end);
				
				CharSequence foundca = viewSource.subSequence(++start, end);
				String found = foundca.toString();
			

				if (!found.startsWith("http://")&&!found.startsWith("/"))
					found = domain + "/" + found;
				
				if (!found.startsWith("http://"))
					found = domain + found;
			
				// next
				cur += 4;// move pointer in text
				cur = viewSource.indexOf(ext, cur);

				
				int sz =0;
				try {sz = getSize(found);
				} catch (Exception e) {}
				if (sz < 300)
					continue;

				row = new JSONObject();
				row.put(SURL, found);
				row.put(SIZE, sz);
				row.put(PAGE, surl);
				list.add(row);

			} catch (Exception e) {
				e.printStackTrace();
				// next
				cur += 4;// move pointer in text
				cur = viewSource.indexOf(ext, cur);

			}


		}// ();

		return list;
	}

	public static JSONArray getImages(String surl) {
		JSONArray list = new JSONArray();
		Source source;
		try {
			source = getPageSource(surl);
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		String domain = "http://" + parseDomainUrl(surl);

		List<Element> elements = source.getAllElements(HTMLElementName.IMG);
		JSONObject row;
		for (Element el : elements) {
			try {
				row = new JSONObject();
				String src = el.getAttributeValue("src");
				if (src.startsWith("/"))
					src = domain + src;
				// else if (!src.startsWith("http"))
				//	 src = surl + "/" + src;

				String alt_txt = el.getAttributeValue("alt");
				if (alt_txt == null)
					alt_txt = "";
				if (alt_txt.contains("advert"))
					continue;

				String wi = el.getAttributeValue("width");
				String he = el.getAttributeValue("height");
				int w = 0;
				int h = 0;
				try {
					w = new Integer(wi);
					h = new Integer(he);
				} catch (Exception e) {
					// _logger.info(e);
				}
				row.put("W_", w);
				row.put("H_", h);

				row.put(SURL, src);
				row.put("ALT_TXT_", alt_txt);

				if (w == 1 && h == 1)
					continue;

				if (w > 1 & w < 100)
					continue;

				if (h > 1 & h < 100)
					continue;
				
						int isz = 0;
				isz=w*h;
				if (w * h == 0) {
					isz = getSize(src);
					if (isz < 300)
						continue;
				}// fi

				row.put(SIZE, isz);
				
				row.put(TYPE, "IMG");
				row.put(PAGE, surl);
				list.add(row);

			} catch (Exception e) {
				e.printStackTrace();
			}
		}// for
		return list;
	}// ()

	public static JSONArray getLinks(String surl) {
		JSONArray list = new JSONArray();

		Source source;
		try {
			source = getPageSource(surl);
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		String domain = "http://" + parseDomainUrl(surl);

		List<Element> elements = source.getAllElements(HTMLElementName.A);
		JSONObject row;
		for (Element el : elements) {
			try {
				row = new JSONObject();
				String url = el.getAttributeValue("href");
				if (url == null)
					continue;
				Segment content = el.getContent();
				String title = " ";
				if (content != null) {
					title = content.getTextExtractor().toString();
					if (title != null)
						row.put(TITLE, title);
				}

				title = title.trim();
				url = url.trim();
				if (url.length() == 0 || title.length() == 0)
					continue;
				if (title.length() > 25 || url.length() > 80)
					continue;
				if (url.contains("avascript"))
					continue;
				if (url.startsWith("#"))
					continue;
				// System.out.println(url);

				if (url.startsWith("/"))
					url = domain + url;

				if (!url.startsWith("http"))
					url = domain + "/" + url;

				row.put(SURL, url);
				row.put(TYPE, "LINK");
				row.put(PAGE, surl);
				list.add(row);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}// for
		return list;
	}

	private static HttpClient getHttpClient() {
		HttpClient client = new HttpClient();
		return client;
	}

	private static Source getPageSource(String fullRequest) throws Exception {

		GetMethod method = new GetMethod();
		method.setURI(new URI(fullRequest, false));

		InputStream inputStream = null;

		int executeMethod = getHttpClient().executeMethod(method);
		if (executeMethod == HttpStatus.SC_OK) {
			inputStream = method.getResponseBodyAsStream();
		} else {

			System.out.println("HTTP Response error code: " + executeMethod);

		}

		Source source = new Source(inputStream);

		return source;
	}

	public static int getSize(String iurl) {
		HttpMethod head = null;
		try {
			head = new HeadMethod(iurl);
			int httpResponseCode = getHttpClient().executeMethod(head);

			if (httpResponseCode != 302 && httpResponseCode != 200) {
				return -1;
				// throw new
				// Exception("Unexpected response code: "+httpResponseCode);
			}
			String size = head.getResponseHeader("Content-Length").getValue();
			return new Integer(size);
		} catch (Exception e) {
			//System.err.println("GetSize");
			//e.printStackTrace();
		} finally {
			if (head != null)
				head.releaseConnection();
		}
		return -1;
	}

	public static String parseDomainUrl(String url) {

		String domain = url;
		String ret = "";
		if (url.startsWith("http://"))
			domain = domain.substring(7);

		int pos = domain.indexOf('/');
		if (pos != -1)
			domain = domain.substring(0, pos);
		pos = domain.lastIndexOf('.');
		if (pos != -1) {
			ret = domain.substring(pos);
			domain = domain.substring(0, pos);
		}
		pos = domain.lastIndexOf('.');
		if (pos == -1)
			return domain + ret;

		domain = domain.substring(pos + 1);
		return domain + ret;
	}// ()

}
